<template>
  <v-container class="pa-0 d-flex flex-column">
    <v-row class="flex-grow-1 no-gutters">
      <v-col cols="6" sm="4" md="3">
        <h1 class="text-center">Nos salles</h1>
        <v-list class="transparent-background">
          <v-list-item
            v-for="room in rooms"
            :key="room.name"
            :input-value="current === room"
            @click="flyTo(room)"
          >
            <v-list-item-content>
              <v-list-item-title>
                {{ room.name }}
              </v-list-item-title>
              <v-list-item-subtitle v-if="room.location.name">
                {{ room.location.name }}
              </v-list-item-subtitle>
              <v-list-item-subtitle v-if="room.location.line1">
                {{ room.location.number }} {{ room.location.line1 }}
              </v-list-item-subtitle>
              <v-list-item-subtitle v-if="room.location.line2">
                {{ room.location.line2 }}
              </v-list-item-subtitle>
              <v-list-item-subtitle>
                {{ room.location.postcode }} {{ room.location.suburb }}
              </v-list-item-subtitle>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </v-col>
      <v-col>
        <client-only>
          <mgl-map
            ref="map"
            :access-token="accessToken"
            :map-style="mapStyle"
            :max-bounds="bounds"
            :center="center"
          >
            <mgl-fullscreen-control position="top-left" />
            <mgl-navigation-control position="top-right" />
            <mgl-marker
              v-for="room in rooms"
              :key="room.name"
              :coordinates="room.location.geo"
              anchor="bottom"
              @click="flyTo(room)"
            />
          </mgl-map>
        </client-only>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapState } from 'vuex'
import 'mapbox-gl/dist/mapbox-gl.css'

const components = {}
if (process.client) {
  const imported = import('vue-mapbox')

  const loader = (name) => async () => (await imported)[name]

  Object.assign(components, {
    MglMap: loader('MglMap'),
    MglNavigationControl: loader('MglNavigationControl'),
    MglFullscreenControl: loader('MglFullscreenControl'),
    MglMarker: loader('MglMarker'),
  })
}

export default {
  components,

  data: () => ({
    accessToken: process.env.mapboxToken,
    mapStyle: 'mapbox://styles/mapbox/satellite-streets-v11',
    current: null,
  }),

  computed: {
    ...mapState(['rooms']),

    bounds() {
      let west
      let east

      let south
      let north

      for (const [key, room] of Object.entries(this.rooms)) {
        const geo = room.location.geo

        if (!west || geo[0] < west) west = geo[0]
        if (!east || geo[0] > east) east = geo[0]
        if (!south || geo[1] < south) south = geo[1]
        if (!north || geo[1] > north) north = geo[1]
      }

      const offset = 0.25
      west -= offset
      south -= offset
      east += offset
      north += offset

      return [west, south, east, north]
    },

    center() {
      const bounds = this.bounds
      return [(bounds[0] + bounds[2]) / 2, (bounds[1] + bounds[3]) / 2]
    },
  },

  methods: {
    async flyTo(room) {
      this.current = room

      await this.$refs.map.actions.flyTo({
        center: room.location.geo,
        zoom: 16,
      })
    },
  },

  head() {
    return {
      title: 'Salles',
    }
  },
}
</script>
